;**************************************************************************************************************************
;Programa, kuri skaito simbolius i duomen failo (input.txt).  rezultat fail (output.txt) atspausdina tik maasias 
;raides. Vienoje eilutje maosios raids, esanios viena greta kitos. Radus ne maj raid, okama  kit eilut ir t.t.
;**************************************************************************************************************************
.MoDEL SMALL
.STACK 100h
.DATA
	duomf db "input.txt", 0				;duomen failo pavadinimas, pasibaigiantis nuliniu simboliu (C sintakse - '\0')
	rezf  db "output.txt", 0				;rezultat failo pavadinimas
	dFail	dw ?						;vieta, skirta saugoti duomen failo deskriptoriaus numer ("handle")
	rFail	dw ?						;vieta, skirta saugoti rezultato failo deskriptoriaus numer
	new_line	 db 13, 10, "$" 			; 10 - new line, 13 - home, "$" - string'o pabaiga
	skaitBuffer  db 1
	pranesimas1  db "Duomenu failas nebuvo ATIDARYTAS!","$"
	pranesimas3  db "Duomenu failas NEBUVO UZDARYTAS!",  "$"
	pranesimas5  db "Skaitant faila ivyko klaida!",  "$"	
	pranesimas7  db "Reazultatu failas NEBUVO SUKURTAS!","$"
	pranesimas8  db "Rezultatu failas NEBUVO ATIDARYTAS!","$"
	pranesimas10 db "Rasant i faila ivyko klaida!",  "$"
	pranesimas11 db "Rezultatu failas NEBUVO UZDARYTAS!",  "$"
.CODE
Start:
	MOV ax,@data
	MOV ds,ax
;*********Duomen failo atidarymas******************	
	MOV ah, 3Dh
	MOV al, 0						;AL = atidarymo tikslas (0  tik skaitymui)
	MOV dx, offset duomf			;DX = nuoroda  failo pavadinim
	INT 21h
	JC atKlaida
	MOV dFail, ax					;AX = duomen failo deskriptoriaus numeris, jis isaugomas  dFail
	JNC rNaujas
	
atKlaida:							;Praneimas, kai duomen failas nra atidarytas
	MOV dx, offset pranesimas1
	MOV ah, 9
	INT 21h
	JMP pabaiga	
	
;*********Rezultat failo sukrimas*************
rNaujas:
	MOV ah, 3Ch
	MOV cx, 0						;CX = failo atributai (0  joki atribut)
	MOV dx, offset rezf				;DX = nuoroda  failo pavadinim
	INT 21h
	JNC pradeti
		
	MOV dx, offset pranesimas7		;Praneimas, kai rezultat failas nebuvo sukurtas
	MOV ah, 9
	INT 21h
	JMP pabaiga

pradeti:	
	MOV rfail, ax					;AX = rezultat failo deskriptoriaus numeris, isaugomas  rFail
;**************************************************
;**********Duomen failo NUSKAITYMAS***************	
	MOV cx, 0201h			;pradzioj cl = 1, tam, kad nepermest  nauj eilut pirmos raids, ch = 2, kad nemest  kit eilut, jei pirma ne maoji raid
skaityti:
	PUSH cx
	MOV ah, 3Fh
	MOV bx, dFail					;BX = failo deskriptoriaus numeris
	MOV dx, offset skaitBuffer		;DX = nuoroda  skaitymo bufer
	MOV cx, 0001h					;CX = kiek bait (daugiausia) nuskaityti
	INT 21h
	JNC neraKlaidos

		MOV dx, offset pranesimas5		;praneimas, kad vyko skaitymo klaida
		MOV ah, 9
		INT 21h
		JMP pabaiga
	
neraKlaidos:
	POP cx
	CMP ax, 0						;tikrina, ar nuskait simboli. Jei nenuskait (ax = 0), nutraukia skaitym bei raym
	JE uzdaryti						;jei nuskait, oka

	CMP byte ptr[skaitBuffer], 60h	;pradeda tikrinti, ar simbolis yra tarp maj raidi
	JG arMaziau
					CMP ch, 2h
					JE skaityti
	MOV cx, 0000h
	JMP skaityti

arMaziau:
	CMP byte ptr[skaitBuffer], 7Ah 	;ubaigia tikrinti, ar simbolis yra tarp maj raidi
	JNA print						;jei tarp maj, spausdina
					CMP ch, 2h
					JE skaityti
	MOV cx, 0000h
	JMP skaityti

;*****RAYMAS  rezultat fail*********	
print:
	CMP cl, 1				;jei cx = 1, tai spausdina maj raid, jei nelygus 1, tai reikia enter
	JE spausd
	PUSH cx
	MOV bx, rFail			;BX = failo deskriptoriaus numeris
	MOV dx, offset new_line
	MOV cx, 0002h			;;(CX = kiek bait rayti) 2 baitai, skirti enter
	MOV ah, 40h				
	INT 21h
	JC rasymoKlaida
	POP cx
	
spausd:	
	MOV bx, rFail		;BX = failo deskriptoriaus numeris
	MOV dx, offset skaitBuffer
	MOV ah, 40h	
	MOV cx, 0001h
	INT 21h
	JC rasymoKlaida
	JMP skaityti
	
uzdaryti:
;*********Duomen failo udarymas******************	
	MOV ah, 3Eh
	MOV bx, dFail
	INT 21h
	JC dUzdKlaida
	
;*********Rezultat failo udarymas****************	
	MOV ah, 3Eh
	MOV bx, rFail
	INT 21h
	JC rUzdKlaida	
	JMP pabaiga
	
;**************************************************	
;**********Informaciniai praneimai****************			
rAtKlaida:								;Praneimas, kai rezultat failas nra atidarytas
	MOV dx, offset pranesimas8
	MOV ah, 9
	INT 21h
	JMP pabaiga	

dUzdKlaida:								;Praneimas, kai duomen failas nra udarytas
	MOV dx, offset pranesimas3
	MOV ah, 9
	INT 21h
	JMP pabaiga
	
rUzdKlaida:	
	MOV dx, offset pranesimas11			;Praneimas, kai rezultat failas nra udarytas
	MOV ah, 9
	INT 21h
	JMP pabaiga	

rasymoKlaida:
	MOV dx, offset pranesimas10
	MOV ah, 9
	INT 21h
	JMP pabaiga
;**************************************************	
	
pabaiga:	
	MOV ax,4c00h
	INT 21h
END Start